package com.zhongzheng.controller.base;

import com.zhongzheng.common.annotation.Log;
import com.zhongzheng.common.core.controller.BaseController;
import com.zhongzheng.common.core.domain.AjaxResult;
import com.zhongzheng.common.core.page.TableDataInfo;
import com.zhongzheng.common.enums.BusinessType;
import com.zhongzheng.common.utils.ServletUtils;
import com.zhongzheng.framework.web.service.WxTokenService;
import com.zhongzheng.modules.base.bo.UserProfileAddBo;
import com.zhongzheng.modules.base.bo.UserProfileEditBo;
import com.zhongzheng.modules.base.bo.UserProfileQueryBo;
import com.zhongzheng.modules.base.service.IUserProfileService;
import com.zhongzheng.modules.base.vo.UserProfileVo;
import com.zhongzheng.modules.user.entity.ClientLoginUser;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;
import java.util.List;

/**
 * 填写资料审核Controller
 *
 * @author ruoyi
 * @date 2021-12-20
 */
@Api(value = "填写盖章审核控制器", tags = {"填写盖章审核控制器"})
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/base/profileStamp")
public class UserProfileStampController extends BaseController {

    private final IUserProfileService iUserProfileService;

    private final WxTokenService wxTokenService;

    /**
     * 新增填写资料审核
     */
    @ApiOperation("新增填写盖章审核")
    @PostMapping()
    public AjaxResult<Void> add(@RequestBody UserProfileAddBo bo) {
        ClientLoginUser loginUser = wxTokenService.getLoginUser(ServletUtils.getRequest());
        bo.setUserId(loginUser.getUser().getUserId());
        bo.setTypeStatus(2);
        return toAjax(iUserProfileService.insertByAddBo(bo) ? 1 : 0);
    }

    /**
     * 修改填写资料审核
     */
    @ApiOperation("修改填写盖章审核")
    @PostMapping("edit")
    public AjaxResult<Void> edit(@RequestBody UserProfileEditBo bo) {
        ClientLoginUser loginUser = wxTokenService.getLoginUser(ServletUtils.getRequest());
        bo.setUserId(loginUser.getUser().getUserId());
        bo.setTypeStatus(2);
        return toAjax(iUserProfileService.updateByEditBo(bo) ? 1 : 0);
    }

    /**
     * 获取填写资料审核详细信息
     */
    @ApiOperation("获取填写盖章审核详细信息")
    @GetMapping("/getInfo")
    public AjaxResult<UserProfileVo> getInfo(UserProfileQueryBo bo) {
        ClientLoginUser loginUser = wxTokenService.getLoginUser(ServletUtils.getRequest());
        bo.setUserId(loginUser.getUser().getUserId());
        bo.setTypeStatus(2L);
        return AjaxResult.success(iUserProfileService.getInfo(bo));
    }

    @ApiOperation("导出盖章word")
    @PostMapping("/addWord")
    public AjaxResult<Void> addWord(@RequestBody UserProfileAddBo bo) throws IOException {
        ClientLoginUser loginUser = wxTokenService.getLoginUser(ServletUtils.getRequest());
        bo.setUserId(loginUser.getUser().getUserId());
        String s =iUserProfileService.addWord(bo);
        return AjaxResult.success(s);
    }

}
